<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('roles', function (Blueprint $table) {
            $table->id();
            $table->string('name', 20);
            $table->timestamps();
            $table->softDeletes();
        });

        Schema::create('barbershop', function (Blueprint $table) {
            $table->id();
            $table->string('name', 50);
            $table->string('contact_number', 15);
            $table->string('landmark', 30);
            $table->text('address');
            $table->date('opened');
            $table->date('closed')->nullable();
            $table->decimal('cash', 10, 2)->default(0.00);
            $table->timestamps();
            $table->softDeletes();
        });

        Schema::create('users', function (Blueprint $table) {
            $table->id();
            $table->foreignId('role_id')->constrained()->cascadeOnDelete();
            $table->foreignId('barbershop_id')->constrained('barbershop')->cascadeOnDelete();
            $table->string('username', 15)->unique();
            $table->string('email')->unique();
            $table->string('password', 60);
            $table->decimal('base_salary', 10, 2)->default(0.00);
            $table->text('sop')->nullable();
            $table->enum('is_active', ['1', '0'])->default('1');
            $table->date('entry_date');
            $table->timestamps();
            $table->softDeletes();
        });

        Schema::create('password_reset_tokens', function (Blueprint $table) {
            $table->string('email')->primary();
            $table->string('token');
            $table->timestamp('created_at')->nullable();
        });

        Schema::create('sessions', function (Blueprint $table) {
            $table->string('id')->primary();
            $table->foreignId('user_id')->nullable()->index();
            $table->string('ip_address', 45)->nullable();
            $table->text('user_agent')->nullable();
            $table->longText('payload');
            $table->integer('last_activity')->index();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('users');
        Schema::dropIfExists('password_reset_tokens');
        Schema::dropIfExists('sessions');
    }
};
